/**************************************************************************
 * Copyright (C) 2012-2021  Unisound
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 **************************************************************************
 *
 * Description : irr.h
 * Author      : yzs.unisound.com
 * Date        : 2021.03.01
 *
 **************************************************************************/
#ifndef __IRR_H__
#define __IRR_H__

/* Cooperation with C and C++ */
#ifdef __cplusplus
extern "C" {
#endif

#include "types.h"

#define IRR_READ_ROW_DATA (1)

unsigned char  irr_init(void);
void irr_poll(void);
int irr_close(void);
int irr_read(void *buffer, uint32_t *len);
int irr_ioctl(uint32_t key,void *buf);
void uni_irr_send_init(unsigned int gpio);
void uni_irr_send_code(unsigned char addr, unsigned char code);

#ifdef __cplusplus
}
#endif

#endif

