/**************************************************************************
 * Copyright (C) 2012-2021  Unisound
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 **************************************************************************
 *
 * Description : lvp_mode_idle.c
 * Author      : yzs.unisound.com
 * Date        : 2021.03.01
 *
 **************************************************************************/

#include <autoconf.h>
#include <stdio.h>
#include <types.h>

#include <board_config.h>

#include "lvp_mode.h"

#define LOG_TAG "[IDLE]"

//=================================================================================================

static int _IdleModeInit(LVP_MODE_TYPE prev_mode)
{
    printf(LOG_TAG"Init IDLE mode\n");

    return 0;
}

static void _IdleModeDone(LVP_MODE_TYPE next_mode)
{
    printf(LOG_TAG"Exit IDLE mode\n");
}

static void _IdleModeTick(void)
{
    ;
}

//-------------------------------------------------------------------------------------------------

const LVP_MODE_INFO lvp_idle_mode_info = {
    .type = LVP_MODE_IDLE,
    .init = _IdleModeInit,
    .done = _IdleModeDone,
    .tick = _IdleModeTick,
};
